#ifndef EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH
#define EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_audio_out_pulse.eo.h"
}

#include "ecore_audio_out.eo.hh"

struct ecore_audio_out_pulse
      : ecore_audio_out
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_out_pulse(Eo* eo)
      : ecore_audio_out(eo)
   {}

   ecore_audio_out_pulse(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_out_pulse(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_out_pulse(ecore_audio_out_pulse const& other)
      : ecore_audio_out(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_out_pulse() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OBJ_OUT_PULSE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_AUDIO_OBJ_OUT_PULSE_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_out_pulse >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_audio_out_pulse >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_out_pulse>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_out_pulse >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out_pulse, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::ecore_audio_out_pulse>
{
   template <typename T>
   struct type
   {
      operator ::ecore_audio_out_pulse() const
      {
         return ::ecore_audio_out_pulse(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_out_pulse>)
{
   return (ECORE_AUDIO_OBJ_OUT_PULSE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH

